/*  Ec  Vers 2.9.1-2     Copyright (C)   2001 Marc Dechico

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/
#include<stdio.h>
#include<ctype.h>
/* type de rock */
#define PET_ROC			0
#define GRA_ROC 		1

/* Valeur possible pour  le camp */
#define BLANC			0
#define NOIR    		1
#define VIDE           -1
#define HOR_ECH        -2

/* test des touches clavier */
#define ESC				27

/* Type de mouvements */
#define MVT_DEP_SIM		0
#define MVT_PRI_SIM		1
#define MVT_PIO_REI		2
#define MVT_PIO_TOU     3
#define MVT_PIO_FOU		4
#define MVT_PIO_CAV		5
#define MVT_PRI_PIO_REI 6
#define MVT_PRI_PIO_TOU 7
#define MVT_PRI_PIO_FOU 8
#define MVT_PRI_PIO_CAV 9
#define MVT_PRI_PAS		10
#define MVT_PET_ROC		11
#define MVT_GRA_ROC		12
/* */
#define NOT_MIN        -32768
    /* le plus grand nombre negatif pour le type int */
/* colonne et ligne */
#define cA              2
#define cB              3
#define cC              4
#define cD              5
#define cE              6
#define cF              7
#define cG              8
#define cH              9

#define l1              2
#define l2              3
#define l3              4
#define l4              5
#define l5              6
#define l6              7
#define l7              8
#define l8              9

/*****************************************************************************/
/* Structure des donnes                                                     */
/*****************************************************************************/
/*   tableau des pices un par camp  */
struct st_pie
{

	int i_pie_sui;					/* pice suivante			   		  */
	int i_pie_pre;                  /* pice precedente 				  */
	int i_pos_x;                    /* position chiquier 				  */
	int i_pos_y;
	int i_for; 				        /* force  							  */
	char c_lib_pie;					/* Libelle piece					  */
	char c_typ_pie;					/* Type    piece					  */
	void (*pf_ini_hst_mvt) (void);	/* ptr sur fonction in_mvt_XXX        */
	void (*pf_jou) (void);			/* ptr sur fonction joue pice		  */
	int (*pf_ech_par)               /* ptr sur fonction echec par 		  */
	(int xd, int yd, int *pi_ech_dir);
	int i_mvt_uni_dir;    	        /* mvt unique pour direction       	  */

};

struct st_pie ts_pie_0[18];			/* pce camp 0			*/
struct st_pie ts_pie_1[18];			/* pice camp 1			*/

/* tableau pointant sur pice camp 0 ou 1 */
struct st_pie *tpts_pie[2];			/* poste 0 camp 0, 1 camp 1 */

/* tableau touver ID piece roi camp [0/1] */
int Id_roi[2];

/* tableau echiquier accs par l'emplacement  */
struct st_ech
{
	int i_cam;
	int i_Id;
};
struct st_ech ts_ech[12][12];

/* tableau correspondance posx <-> libelle colonne */
char tc_lib_col[12];

/* tableau historique des coups */
struct st_hst_pro
{
	int i_pro;						/* profondeur pour test du ptr pts_hst_pro */
	void (**ptpf_mvt) (void);		/* ptr sur fonction  mouvement          */
	int i_cam;						/* camp				 					*/
	int i_cam_adv;					/* camp	 adverse           				*/
	int i_Id;                 		/* Idetifiant pice  					*/
	int i_pos_x;                   	/* pos. chiquier 						*/
	int i_pos_y;
	int i_typ_mvt;					/* type mouvement 						*/
	int i_dir_sui;					/* direction suivante					*/
	int i_pos_ori_x;               	/* pos. origine			 				*/
	int i_pos_ori_y;
	int i_Id_2p;                   	/* Id deuxime pice	 				*/
	int i_pos_x_R_p_c;	            /* Position x roi propre camp	 		*/
	int i_pos_y_R_p_c;	            /* Position y roi propre camp	 		*/
	int i_pos_x_R_c_a;	            /* Position x roi camp	adverse 		*/
	int i_pos_y_R_c_a;	            /* Position y roi camp	adverse 		*/
	int i_ech;						/* echec par pice principale 			*/
									/* ou secondaireou par demasquge 	   	*/
	int i_ech_dir_pri;	            /* dir. pice principale ou secondaire  */
									/* causant echec sur camp adverse       */
									/* (si valeur  <> 0 alors echec)  		*/
	int i_ech_dir_dem;	            /* dir.demasaquage causant eventuel  	*/
									/* echec sur camp  adverse              */
	int i_ech_dir_dem_p_c;          /* direction demasaquage causant echec	*/
									/* sur propre camp                      */
	int i_pat;			            /* pat      	     					*/
	int i_mat;			            /* mat 			     					*/
	int i_not;						/* note 								*/
	int i_not_max;					/* note maximum							*/
	int ti_roc_cam_typ[2][2];       /* [cam][type] type: 0= petit 1= grd 	*/
									/* Si = 1 alors piece deplace			*/
									/* Suppression non signale				*/

};

struct st_hst_pro ts_hst_pro[100];

/* Tableau donnant l'ID de la tour suivant le roc et le cam			 */
int ti_tou_cam_typ[2][2];        /* Camp: NOIR/BLANC Typ GRA_ROC/PET_ROC */


/* tableau ptr de tableau ptr de fonction mvt roi */
void (**ptpf_mvt_roi[12][12]) (void);
/* tableau de ptr fonction  suivant position roi */
void (*tpf_roi_h_g		[4]) 	(void);
void (*tpf_roi_h		[6]) 	(void);
void (*tpf_roi_pos_ori_0[8]) 	(void);
void (*tpf_roi_h_d		[4]) 	(void);
void (*tpf_roi_d  		[6]) 	(void);
void (*tpf_roi_b_d		[4]) 	(void);
void (*tpf_roi_b  		[6]) 	(void);
void (*tpf_roi_pos_ori_1[8]) 	(void);
void (*tpf_roi_b_g  	[4]) 	(void);
void (*tpf_roi_g  		[6]) 	(void);
void (*tpf_roi_nor		[9]) 	(void);

/* tableau de structure mvt reine*/
void (**ptpf_mvt_rei[12][12]) (void);
/* tableau de ptr fonction  suivant position reine */
void (*tpf_rei_h_g		[4]) 	(void);
void (*tpf_rei_h		[6]) 	(void);
void (*tpf_rei_h_d		[4]) 	(void);
void (*tpf_rei_d  		[6]) 	(void);
void (*tpf_rei_b_d		[4]) 	(void);
void (*tpf_rei_b  		[6]) 	(void);
void (*tpf_rei_b_g  	[4]) 	(void);
void (*tpf_rei_g  		[6]) 	(void);
void (*tpf_rei_nor		[9]) 	(void);

/* tableau de structure mvt fou  */
void (**ptpf_mvt_fou[12][12]) (void);
/* tableau de ptr fonction  suivant position fou */
void (*tpf_fou_h_g		[2]) 	(void);
void (*tpf_fou_h		[3]) 	(void);
void (*tpf_fou_h_d		[2]) 	(void);
void (*tpf_fou_d  		[3]) 	(void);
void (*tpf_fou_b_d		[2]) 	(void);
void (*tpf_fou_b  		[3]) 	(void);
void (*tpf_fou_b_g  	[2]) 	(void);
void (*tpf_fou_g  		[3]) 	(void);
void (*tpf_fou_nor		[5]) 	(void);

/* tableau de structure mvt tour */
void (**ptpf_mvt_tou[12][12]) (void);
/* tableau de ptr fonction  suivant position tour */
void (*tpf_tou_h_g		[3]) 	(void);
void (*tpf_tou_h		[4]) 	(void);
void (*tpf_tou_h_d		[3]) 	(void);
void (*tpf_tou_d  		[4]) 	(void);
void (*tpf_tou_b_d		[3]) 	(void);
void (*tpf_tou_b  		[4]) 	(void);
void (*tpf_tou_b_g  	[3]) 	(void);
void (*tpf_tou_g  		[4]) 	(void);
void (*tpf_tou_nor		[5]) 	(void);

/* tableau de structure mvt cacalier */
void (**ptpf_mvt_cav[12][12]) (void);
/* tableau de ptr fonction  suivant position cavalier */
void (*tpf_cav_c_h_g	[3]) 	(void);
void (*tpf_cav_h_g		[4]) 	(void);
void (*tpf_cav_h		[5]) 	(void);
void (*tpf_cav_h_d  	[4]) 	(void);
void (*tpf_cav_c_h_d	[3]) 	(void);
void (*tpf_cav_d_h  	[4]) 	(void);
void (*tpf_cav_d    	[5]) 	(void);
void (*tpf_cav_d_b  	[4]) 	(void);
void (*tpf_cav_c_b_d	[3]) 	(void);
void (*tpf_cav_b_d   	[4]) 	(void);
void (*tpf_cav_b        [5])  	(void);
void (*tpf_cav_b_g  	[4]) 	(void);
void (*tpf_cav_c_b_g	[3]) 	(void);
void (*tpf_cav_g_b  	[4]) 	(void);
void (*tpf_cav_g    	[5]) 	(void);
void (*tpf_cav_g_h  	[4]) 	(void);
void (*tpf_cav_i_c_h_g	[5]) 	(void);
void (*tpf_cav_i_h  	[7]) 	(void);
void (*tpf_cav_i_c_h_d	[5]) 	(void);
void (*tpf_cav_i_d 		[7]) 	(void);
void (*tpf_cav_i_c_b_d	[5]) 	(void);
void (*tpf_cav_i_b		[7]) 	(void);
void (*tpf_cav_i_c_b_g	[5]) 	(void);
void (*tpf_cav_i_g		[7]) 	(void);
void (*tpf_cav_nor		[9]) 	(void);

/* tableau de structure mvt piont camp 0 */
void (**ptpf_mvt_pio_0[12][12]) (void);
/* tableau de ptr fonction  suivant position pion */
void (*tpf_pio_0_L2_g 	[4]) 	(void);
void (*tpf_pio_0_L2 	[5]) 	(void);
void (*tpf_pio_0_L2_d 	[4]) 	(void);

void (*tpf_pio_0_L346_g [3]) 	(void);
void (*tpf_pio_0_L346 	[4]) 	(void);
void (*tpf_pio_0_L346_d	[3]) 	(void);

void (*tpf_pio_0_L5_g   [4]) 	(void);
void (*tpf_pio_0_L5 	[6]) 	(void);
void (*tpf_pio_0_L5_d	[4]) 	(void);

void (*tpf_pio_0_L7_g   [5]) 	(void);
void (*tpf_pio_0_L7 	[7]) 	(void);
void (*tpf_pio_0_L7_d	[5]) 	(void);

/* tableau de structure mvt piont camp 1 */
void (**ptpf_mvt_pio_1[12][12]) (void);
/* tableau de ptr fonction  suivant position pion */
void (*tpf_pio_1_L7_g 	[4]) 	(void);
void (*tpf_pio_1_L7 	[5]) 	(void);
void (*tpf_pio_1_L7_d 	[4]) 	(void);

void (*tpf_pio_1_L653_g [3]) 	(void);
void (*tpf_pio_1_L653 	[4]) 	(void);
void (*tpf_pio_1_L653_d	[3]) 	(void);

void (*tpf_pio_1_L4_g   [4]) 	(void);
void (*tpf_pio_1_L4 	[6]) 	(void);
void (*tpf_pio_1_L4_d	[4]) 	(void);

void (*tpf_pio_1_L2_g   [5]) 	(void);
void (*tpf_pio_1_L2 	[7]) 	(void);
void (*tpf_pio_1_L2_d	[5]) 	(void);


/* tableau de correpondance coordonn cavalier/roi <-> ech_dir */
int ti_ech_dir_cav[5][5];


/* tableau de ptr fonction restore echiquier */
/*pour chaque type de mouvement  */
void (*tpf_res_pie_pri[13]) 	(void); /* pice principale */
void (*tpf_res_pie_sec[13]) 	(void); /* pice secondaire */
int ti_typ_mvt_pri[13];					/* 1 si prise pice */
/* tableau ptr fonction controle roi echec */
int (*pf_cas_ctl_pos[12][12]) (int xx, int yy);


/* chargement du tableau (statique) controle  nouveau echec demasquage*/
int (*tpf_cas_ctl_sta[27]) (int x,int y,int i_cam_adv);

/* tableau note du mvt initial */
struct st_not_mvt_ini
{
	int i_Id;					/* pice mouvemente 		*/
	int c_lib_pie;              /*  libelle piece 			*/
	int i_typ_mvt;				/* type mouvement 			*/
	int i_pos_ori_x;            /* pos d'origine chiquier 	*/
	int i_pos_ori_y;
	int i_pos_arr_x;            /* pos arrivee chiquier 	*/
	int i_pos_arr_y;
	int ti_nbr_pat[2];     		/* nbre de pat camp 0/1  	*/
	int ti_nbr_mat[2];     		/* nbre de mat camp 0/1   	*/
	int i_not_mvt_ini;     		/* note  cumulee mouvement	*/
};

struct st_not_mvt_ini ts_not_mvt_ini[150];

/*****************************************************************************/
/* Variables                                                                 */
/*****************************************************************************/
char c_jou[2];						/* jou[x]=h(human) or m(machine)	*/
									/* jou[0] blanc jou[1] noir			*/
int i_pro_act;                 		/* profondeur actuelle 				*/
int i_pro_sim_niv;					/* niveau de simulation 			*/
int i_pro_sim_inc;					/* nivde simu pour incrment		*/
int i_pro_sim_act;             		/* profondeur de simulation 		*/
int i_pro_sim_max_sup;         		/* profondeur maximale superieur 	*/
int i_pro_sim_max_inf;         		/* profondeur maximale inferieur	*/
int i_pro_sim_int_cla;         		/* profondeur d'interruption clavier*/
int i_sim_end;				   		/* si = 1 fin de simulation 		*/
int i_not_cpt_mvt_ini;				/* note: compteur mvt initial 		*/
int i_not_num_mvt_cho;				/* note n du mvt choisi 			*/
struct st_hst_pro	*pts_hst_pro; 	/* ptr sur tableau structure historique  */
struct st_hst_pro	*pts_hst_pro_p; /* ptr sur tableau structure historique  */
									/* profondeur precedente 				 */
struct st_pie  		*pts_pie;      	/* ptr sur tbl structure pice principale*/

/* variable de travaille locale  */
struct st_pie  		*pts_pie_sui;    /* ptr sur tbl struct pice suivante 	 */
struct st_pie  		*pts_pie_pri;    /* ptr sur tbl struct pice prise    	 */
struct st_pie  		*pts_pie_tou_roc;/* ptr sur tbl struct pice tour roc	 */
struct st_pie  		*pts_pie_pre_pri;/* ptr tbl struct pice (prec. prise)   */
struct st_pie  		*pts_pie_sui_pri;/* ptr tableau structpice (suive prise)*/
struct st_pie  		*pts_pie_roi_p_c;/* ptr tableau structpice (suive prise)*/
struct st_pie  		*pts_pie_roi_c_a;/* ptr tableau structpice (suive prise)*/
struct st_ech		*pts_ech;		 /* ptr tableau struct echiquier		 */
int    x,y;							 /* position pice 						 */
int    xx,yy;						 /* position pice 						 */
int    i_cam_adv;					 /* position pice 						 */
char   c_typ_pie;					 /* position pice 						 */
char   *pc_typ_pie;					 /* pointeur caracre type de pice      */
/* variable test */
unsigned long int cpt;
int c;
int i_nbr_pat;
int i_nbr_mat;
int i_nbr_mat_pre;
int i_nbr_ech;
/*****************************************************************************/
/*prototype de fonction                                                      */
/*****************************************************************************/
/* test   */
void test (void); /*bug */
void test2 (void); /*perfo*/

/* initialisation et chargement tableau */
int 	ini_hst_cam (int i_cam_hst_0);
void 	ini_pgm 	(void);
int 	ajo_pie 	(int i_cam,char c_cod_pie,int i_pos_x, int i_pos_y);

/* menu de commande  */
void mnu_cde (void);
void mnu_hlp (void);
void jou 	 (char *ptc_dep,    /* joue							  */
			  char *ptc_arr);

void jou_pro_sui(int i_pos_dep_x,   /* initialisation profondeur suivante */
				 int i_pos_dep_y,
				 int i_pos_arr_x,
				 int i_pos_arr_y);
void jou_roi(void);                 /* joue roi						  	*/
void jou_grd_roc_0 	(void);	 		/* joue roi grd rock blanc          */
void jou_grd_roc_1 	(void);	 		/* joue roi	grd rock noir           */
void jou_pet_roc_0 	(void);	 		/* joue roi	petit rock blanc	 	*/
void jou_pet_roc_1 	(void);	 		/* joue roi	petit rock noir			*/
void jou_mvt_roi_roc(int i_pos_x_tou,/* joue roi	fct commune rock*/
					 int i_pos_y_tou);


void jou_ctfr	(void); 		/* joue cavalier tour fou reine		*/
void jou_pio_0 	(void); 		/* joue pion blanc					*/
void jou_pio_1 	(void); 		/* joue pion noir 					*/
void jou_mvt_pio(void); 		/* joue pion fct commune rock		*/
int  cho_rem_pio(void);			/* choix pour remplacement du pion  */

void ann_cou 	(void);			/* annule coup					  	*/
void pro_pre 	(void);			/* profondeur precedente		  	*/

int  tra_col (char c_col);      /* pour transformer A1 en x=2,y=2 */
int  tra_lig (char c_lig);

/* affichage de l'chiquier */
void aff_ech (int i_cam);
void aff_pie (int i_cam);
void aff_hst (int i_pro_deb,
			  int i_pro_fin);
void aff_not 	(void);
void aff_not_2 	(void);

/* gestion interruption clavier */
int  get_key (void);


/* simulation */
void simul		 (void);
void sto_sim 	 (void);		/* Stop simulation si touche escape */

/* piece suivante              */
void pie_sui 	(void);

/* Direction suivante */
void dir_sui(void);

/* Initialisation profondeur */
void pro_sui(void);

/* Copie 
val grand/petit rock */
/* pour propre camp */
void cop_val_grc_pc (void);
void cop_val_prc_pc (void);
/* camp adverse */
void cop_val_grc_ca (void);
void cop_val_prc_ca (void);


/* initialisation hst avec pos roi camp propre et adverse*/
void hst_pos_roi (void);

/* fonctions de deplacement */
void dep_sim(void);							/* deplacement simple 		*/
void pri_sim(void);							/* prise simple 			*/
void pio_rei(void);							/* pion en reine			*/
void pio_fou(void);							/* pion en fou 				*/
void pio_tou(void);							/* pion en tou 				*/
void pio_cav(void);							/* pion en cav 				*/
void pri_pio_rei(void);						/* pion en reine + prise 	*/
void pri_pio_fou(void);						/* pion en fou + prise 		*/
void pri_pio_tou(void);						/* pion en tou + prise 		*/
void pri_pio_cav(void);						/* pion en cav + prise 		*/
void pri_pas(void);							/* prise ne passant			*/
void dep_pet_roc_0(void);                   /* petit rock blanc			*/
void dep_pet_roc_1(void);                   /* petit rock noir			*/
void dep_grd_roc_0(void);                   /* grand rock blanc			*/
void dep_grd_roc_1(void);                   /* grand rock noir			*/

/* fonction de restoration position */
/* piece principale */
void pie_pri_res(void);						/*  piece principale		*/
void roi_grd_roc_res(void);					/*  roi grand rock			*/ 
									/* inutil */
void roi_pet_roc_res(void);					/*  roi petit rock			*/
									/* inutil */
void pio_res(void);			  				/*  pion en cav,tou,fou,rei	*/
void pio_res_2(void);		  				/*  pion en cav,tou,fou,rei	*/ 
									/* optimisation il faudrait pouvoir */
									/* "simplifier" cela 		*/
/* piece secondaire */
void pie_sup_res(void);						/*  pice supprime			*/
void tou_grd_roc_res(void);					/*  tour grand rock			*/
void tou_pet_roc_res(void);					/*  tour petit rock			*/
void pri_pio_res(void);						/*  pion en cav,tou,fou,rei */
											/* + prise                  */
/* fonction modification du pion en cavalier,tour,fou,reine*/
void pio_cav(void);							/*  pion en cav */
void pio_rei(void);							/*  pion en rei */
void pio_tou(void);							/*  pion en tou */
void pio_fou(void);							/*  pion en fou */

/* initialisation hst avec pointeur sur tableau de fct mvt */
void ini_hst_mvt_roi(void);
void ini_hst_mvt_rei(void);
void ini_hst_mvt_tou(void);
void ini_hst_mvt_fou(void);
void ini_hst_mvt_cav(void);
void ini_hst_mvt_pio_0(void);
void ini_hst_mvt_pio_1(void);

/* Calcul position suivant la direction */
/* pour tour, fou, reine */
void haut_gauche 	(void);
void haut_droite  	(void);
void bas_gauche 	(void);
void bas_droite  	(void);
void haut 			(void);
void bas 			(void);
void gauche 		(void);
void droite 		(void);
/* cas paticulier pour gestion possibilit du rock */
/* pour la tour si pos en coin echiquier		   */
void haut_tou_gr 		(void);
void bas_tou_gr 		(void);
void haut_tou_pr 		(void);
void bas_tou_pr 		(void);
void droite_tou_gr		(void);
void gauche_tou_pr		(void);
/* fonction commune tour fou reine */
void mvt_tfr		(void);
/* cas paticulier pour gestion possibilit du rock */
/* pour la tour si pos en coin echiquier		   */
void mvt_tou_gr		(void);
void mvt_tou_pr		(void);

/* pour cavalier */
void haut_droite_C 	(void);
void droite_haut_C 	(void);
void droite_bas_C	(void);
void bas_droite_C  	(void);
void bas_gauche_C 	(void);
void gauche_bas_C 	(void);
void gauche_haut_C	(void);
void haut_gauche_C  (void);
/* fonction commune cavalier */
void mvt_cav		(void);

/* pour roi */
void haut_gauche_R 	(void);
void haut_droite_R 	(void);
void bas_gauche_R 	(void);
void bas_droite_R  	(void);
void haut_R 		(void);
void bas_R		(void);
void gauche_R 		(void);
void droite_R 		(void);
void grd_roc_0 	(void);
void pet_roc_0 	(void);
void grd_roc_1 	(void);
void pet_roc_1 	(void);
/* fonction commune roi */
void mvt_roi		(void);
void mvt_roi_pet_roc 	(int i_pos_x_tou,int i_pos_y_tou);
void mvt_roi_gra_roc 	(int i_pos_x_tou,int i_pos_y_tou);

/* pour pion camp 0 */
void haut_gauche_p_0(void);
void haut_droite_p_0(void);
void haut_gauche_pas_p_0(void);
void haut_droite_pas_p_0(void);
void haut_gauche_cav_p_0(void);
void haut_droite_cav_p_0(void);
void haut_gauche_rei_p_0(void);
void haut_droite_rei_p_0(void);
void haut_cav_p_0 	(void);
void haut_rei_p_0 	(void);
void haut_1_p_0 	(void);
void haut_2_p_0		(void);

/* pour pion camp 1 */
void bas_gauche_p_1(void);
void bas_droite_p_1(void);
void bas_gauche_pas_p_1(void);
void bas_droite_pas_p_1(void);
void bas_gauche_cav_p_1(void);
void bas_droite_cav_p_1(void);
void bas_gauche_rei_p_1(void);
void bas_droite_rei_p_1(void);
void bas_cav_p_1 	(void);
void bas_rei_p_1 	(void);
void bas_1_p_1 	(void);
void bas_2_p_1     (void);

/* fonction commune pion */
void mvt_pio		(void);

/* controle si la piece  mouvementee cause un echec*/
int ech_par_rei     (int xd, int yd, int *pi_ech_dir);
int ech_par_fou     (int xd, int yd, int *pi_ech_dir);
int ech_par_tou     (int xd, int yd, int *pi_ech_dir);
int ech_par_cav     (int xd, int yd, int *pi_ech_dir);
int ech_par_pio_0   (int xd, int yd, int *pi_ech_dir);
int ech_par_pio_1   (int xd, int yd, int *pi_ech_dir);

/* controle si case controle par adversaire */
int cas_ctl_sta    (int x,int y,int i_cam_adv);

/* cas ctl spcifique  une position dans l'echiquier */
/* case exterieur */
int cas_ctl_pos_c_h_g	  (int xx, int yy);
int cas_ctl_pos_c_h_d	  (int xx, int yy);
int cas_ctl_pos_c_b_d	  (int xx, int yy);
int cas_ctl_pos_c_b_g	  (int xx, int yy);

int cas_ctl_pos_h_g		  (int xx, int yy);
int cas_ctl_pos_h_d		  (int xx, int yy);
int cas_ctl_pos_d_h		  (int xx, int yy);
int cas_ctl_pos_d_b		  (int xx, int yy);
int cas_ctl_pos_b_d		  (int xx, int yy);
int cas_ctl_pos_b_g		  (int xx, int yy);
int cas_ctl_pos_g_b		  (int xx, int yy);
int cas_ctl_pos_g_h		  (int xx, int yy);

int cas_ctl_pos_h		  (int xx, int yy);
int cas_ctl_pos_d		  (int xx, int yy);
int cas_ctl_pos_b		  (int xx, int yy);
int cas_ctl_pos_g		  (int xx, int yy);

/* case interieur */
int cas_ctl_pos_i_c_h_g	  (int xx, int yy);
int cas_ctl_pos_i_c_h_d	  (int xx, int yy);
int cas_ctl_pos_i_c_b_d	  (int xx, int yy);
int cas_ctl_pos_i_c_b_g	  (int xx, int yy);

int cas_ctl_pos_i_h		  (int xx, int yy);
int cas_ctl_pos_i_d		  (int xx, int yy);
int cas_ctl_pos_i_b		  (int xx, int yy);
int cas_ctl_pos_i_g		  (int xx, int yy);

/* case normale */
int cas_ctl_pos_nor		  (int xx, int yy);

/* echec: calcul direction demasquage */
void ech_cal_dir_dem  (int i_cam_roi,int *pi_ech_dir_dem);

/* fct pour controle roi  nouveau echec     */
/* oblique: fou et reine */
int cas_ctl_h_d     (int x,int y,int i_cam_adv);
int cas_ctl_h_g     (int x,int y,int i_cam_adv);
int cas_ctl_b_d     (int x,int y,int i_cam_adv);
int cas_ctl_b_g     (int x,int y,int i_cam_adv);

/* droite  tour et reine */
int cas_ctl_h     (int x,int y,int i_cam_adv);
int cas_ctl_b     (int x,int y,int i_cam_adv);
int cas_ctl_d     (int x,int y,int i_cam_adv);
int cas_ctl_g     (int x,int y,int i_cam_adv);

/* cavalier */
int cas_ctl_cav_h_d     (int x,int y,int i_cam_adv);
int cas_ctl_cav_d_h     (int x,int y,int i_cam_adv);
int cas_ctl_cav_d_b     (int x,int y,int i_cam_adv);
int cas_ctl_cav_b_d     (int x,int y,int i_cam_adv);
int cas_ctl_cav_b_g     (int x,int y,int i_cam_adv);
int cas_ctl_cav_g_b     (int x,int y,int i_cam_adv);
int cas_ctl_cav_g_h     (int x,int y,int i_cam_adv);
int cas_ctl_cav_h_g     (int x,int y,int i_cam_adv);

/* pion */
int cas_ctl_pio_g     	(int x,int y,int i_cam_adv);
int cas_ctl_pio_d     	(int x,int y,int i_cam_adv);

/* roi */
int cas_ctl_roi_h     	(int x,int y,int i_cam_adv);
int cas_ctl_roi_h_d    	(int x,int y,int i_cam_adv);
int cas_ctl_roi_d     	(int x,int y,int i_cam_adv);
int cas_ctl_roi_b_d    	(int x,int y,int i_cam_adv);
int cas_ctl_roi_b     	(int x,int y,int i_cam_adv);
int cas_ctl_roi_b_g    	(int x,int y,int i_cam_adv);
int cas_ctl_roi_g     	(int x,int y,int i_cam_adv);
int cas_ctl_roi_h_g    	(int x,int y,int i_cam_adv);

/* calcule et mmorisation de la note du mvt initial */
void not_cal (void);
/* raz de la structure note mvt ini  avant simulation */
void not_mvt_ini_raz(void);
